该题其实只需要利用multiset维护一下就可以了。
根据题意, 利用题目特点, 可以发现, 如果正着枚举的话, 前面的对后面的会产生影响, 但是, 如果我们倒着枚举就可以避免这个情况。
所以我们不妨先记录每个时间点释放魔法的次数, 然后倒着枚举, 这样当前这个数的能力值就是v+res (res为当前附加的魔法值, 因为后面时间增加的魔法,对于前面时间也一定增加了)。 所以, 我们不妨将每个值放进multiset, 然后二分查找对方组里是否存在比当前数大的数。 复杂度O(n*log(n))
细节参见代码:
~~~
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<string>
#include<vector>
#include<stack>
#include<bitset>
#include<cstdlib>
#include<cmath>
#include<set>
#include<list>
#include<deque>
#include<map>
#include<queue>
#define Max(a,b) ((a)>(b)?(a):(b))
#define Min(a,b) ((a)<(b)?(a):(b))
using namespace std;
typedef long long ll;
const double PI = acos(-1.0);
const double eps = 1e-6;
const int INF = 1000000000;
const int maxn = 50000 + 10;
const int maxv = 1000000 + 10;
int T,n,m,vis[maxv],b,time[maxn];
struct node {
int id, v;
node(int ii=0, int vv=0):id(ii), v(vv) {}
}a[maxn];
multiset<int> g1, g2;
int main() {
scanf("%d",&T);
while(T--) {
scanf("%d%d",&n,&m);
g1.clear(); g2.clear();
multiset<int> :: iterator it;
memset(vis, 0, sizeof(vis));
for(int i=1;i<=n;i++) scanf("%d%d",&a[i].id,&a[i].v);
for(int i=0;i<m;i++) {
scanf("%d",&b);
vis[b]++;
}
int res = 0, ans = 0;
for(int i=n;i>=1;i--) {
res += vis[i];
if(a[i].id == 0) {
g1.insert(a[i].v+res);
it = g2.upper_bound(a[i].v+res);
if(it != g2.end()) ++ans;
}
else {
g2.insert(a[i].v+res);
it = g1.upper_bound(a[i].v+res);
if(it != g1.end()) ++ans;
}
}
printf("%d\n",n-ans);
}
return 0;
}
~~~
- 前言
- 1608 - Non-boring sequences(折半递归。。暂且这么叫吧)
- 11491 - Erasing and Winning(贪心)
- 1619 - Feel Good(高效算法-利用数据结构优化-优先队列)
- hdu-4127 Flood-it!(IDA*算法)
- UESTC 1132 酱神赏花 (用数据结构优化DP)
- HDU 2874 Connections between cities(LCA离线算法)
- Codeforces Round #317 A. Lengthening Sticks(组合+容斥)
- HDU 3085 Nightmare Ⅱ(双向BFS)
- HDU 5592 ZYB&#39;s Premutation(二分+树状数组)
- Codeforces Round #320 (Div. 1) C. Weakness and Poorness(三分)
- HDU 5212 Code(容斥)
- HDU 5596 GTW likes gt(multiset)
- FZU 2159 WuYou(贪心)
- HDU 3450 Counting Sequences(DP + 树状数组)
- HDU 5493 Queue(二分+树状数组)
- HDU 1166 敌兵布阵(线段树版)
- HDU 1394 Minimum Inversion Number(树状数组||线段树)
- HDU 2795 Billboard(线段树)
- POJ 2828 Buy Tickets(树状数组)
- 《完全版线段树》- NotOnlySuccess
- POJ 2886 Who Gets the Most Candies?(树状数组+二分)
- HDU 1698 Just a Hook(线段树区间修改)
- POJ 3468 A Simple Problem with Integers(线段树|区间加减&amp;&amp;区间求和)
- POJ 2528 Mayor&#39;s posters(线段树区间修改+离散化)
- HDU 5606 tree(并查集)
- POJ 3734 Blocks(矩阵优化+DP)
- POJ 3233 Matrix Power Series(矩阵优化)
- HDU 5607 graph(矩阵优化+概率DP)
- POJ 2777 Count Color(线段树区间修改+位运算)
- POJ 1436 Horizontally Visible Segments(线段树区间修改)
- UVA 1513 - Movie collection(树状数组)
- UVA 1232 - SKYLINE(线段树区间更新)
- 11525 - Permutation(二分+树状数组)
- 11402 - Ahoy, Pirates!(线段树区间更新(标记重叠的处理))
- Educational Codeforces Round 6 E. New Year Tree(DFS序+线段树)